using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using MacGruber;
using UnityEngine;
using SimpleJSON;
using MVR.FileManagementSecure;
using UnityEngine.Serialization;
using Random = UnityEngine.Random;


namespace CheesyFX {

	public class ReadMyLips : MVRScript
	{
		public static ReadMyLips singleton;
		private UnityEventsListener uiListener;
		private GenerateDAZMorphsControlUI morphControl;
		private static System.Random rng = new System.Random();  
		// private static Dictionary<JSONStorableFloat, float> painMorphps= new Dictionary<JSONStorableFloat, float>();
		// private static Dictionary<JSONStorableFloat, float> joyMorphs= new Dictionary<JSONStorableFloat, float>();
		// private static Dictionary<JSONStorableFloat, float> lastMorphs= new Dictionary<JSONStorableFloat, float>();
		private static List<ExpressionMorph> painMorphs = new List<ExpressionMorph>();
		private static List<ExpressionMorph> joyMorphs = new List<ExpressionMorph>();
		private static List<ExpressionMorph> lastMorphs = new List<ExpressionMorph>();
		private static JSONStorableBool autoJaw = new JSONStorableBool("Auto Jaw", true);
		public static JSONStorableFloat maxMorphVal = CheesyUtils.SetupJSONFloat("Max Morph Value", .1f, 0f, 1f);
		public static JSONStorableFloat painThresholdJ = CheesyUtils.SetupJSONFloat("Pain Thresold", 1f, 0f, 1f, true);
		public static JSONStorableFloat joyExpressionScale = CheesyUtils.SetupJSONFloat("Joy Expression Scale", 20f, 1f, 40f, true);
		public static JSONStorableFloat painExpressionScale = CheesyUtils.SetupJSONFloat("Pain Expression Scale", 7f, 1f, 10f, true);
		public static JSONStorableFloat expressionsChangeChance = new JSONStorableFloat("Expression Change Chance", .1f, 0f, 1f);
		public static JSONStorableFloat randomBurstChanceJ = new JSONStorableFloat("Random Burst Chance", .07f, 0f, 1f);
		public static JSONStorableFloat randomBurstStrenght = new JSONStorableFloat("Random Burst Strength", 5f, 0f, 10f);
		public static JSONStorableFloat jawLimit = new JSONStorableFloat("Jaw Limit", -12f, -35f, 0f);
		public static JSONStorableFloat headAudioVolume = new JSONStorableFloat("Head Audio Volume", 1f, 0f, 1f);
		public static JSONStorableFloat headAudioPitch = new JSONStorableFloat("Head Audio Pitch", 1f, -3f, 3f);
		
		private static JSONStorableFloat sexMoanChanceJ = new JSONStorableFloat("Sex Moan Chance", .1f, 0f, 1f, true);
		public static JSONStorableFloat slapMoanChance = new JSONStorableFloat("Slap Moan Chance", 1f, 0f, 1f, true);
		public static JSONStorableFloat sexSlapMoanChance = new JSONStorableFloat("Sex Slap Moan Chance", .4f, 0f, 1f, true);
		public static JSONStorableFloat burstMoanChance = new JSONStorableFloat("Burst Moan Chance", .5f, 0f, 1f, true);

		public static JSONStorableFloat orgasmCount = new JSONStorableFloat("Orgasms", 0f, 0f, 10f, false, false);
		public static JSONStorableFloat stimulation = new JSONStorableFloat("Stimulation", 0f, 0f, 1f, true, false);
		public static JSONStorableFloat stimulationGain = new JSONStorableFloat("Stimulation Gain", .1f, 0f, 1f, true);
		public static JSONStorableFloat stimulationRegressionJ = new JSONStorableFloat("Stimulation Regression", .15f, 0f, 1f, true);
		public static JSONStorableFloat orgasmThreshold = new JSONStorableFloat("Orgasm Threshold", 1f, 0f, 1f);
		public static JSONStorableFloat orgasmRecoverTime = new JSONStorableFloat("Orgasm Recover Time", 120f, 0f, 900f, false);
		private List<CustomFloatTrigger> stimTriggers = new List<CustomFloatTrigger>();
		private List<CustomFloatTrigger> orgasmTriggers = new List<CustomFloatTrigger>();
		private static float resetTargetsTimer = 1f;
		private static float stimBurstTimer;
		public static float randomBurstChance;
		public static float sexMoanChance;
		public static float stimulationRegression;
		private static float painThreshold;
		private static float orgasmTimer = 30f;
		private static float orgRecoverTimer = orgasmRecoverTime.defaultVal;
		private static bool isOrgasming;
		private static bool isOrgasmEnd;
		private static bool isIdling = true;
		
		private bool vammoanPackageInstalled;
		public static List<ClipLibrary> moanLibrary;
		public static AudioSource headAudioSource;
		public static JSONStorableStringChooser vamMoanVoice;
		public static JSONStorableStringChooser voice = new JSONStorableStringChooser("vammoanSlapVoice",
			new List<string>{"Abby", "Claire", "Ella", "Emma", "Grace", "Isabella", "Lana", "Lia", "Lillian", "Lise", "Seth", "Skye", "Yumi"},
			"Isabella", "VAMMoan Voice");

		public static AudioSourceControl headAudioControl;
		public static DAZMeshEyelidControl eyelidBehavior;
		private static AdjustJoints jawControl;
		// private static JSONStorable autoJawMouthMorphs;
		public static float blinkTimeout;
		private List<object> UIElements = new List<object>();
		private UIDynamicTabBar tabbar;
		
		public static EventTrigger onOrgasmStartTrigger;
		public static EventTrigger onOrgasmEndTrigger;
		public static EventTrigger onOrgasmRecoverTrigger;

		public override void Init()
		{
			singleton = this;
			headAudioControl = (AudioSourceControl)containingAtom.GetStorableByID("HeadAudioSource");
			eyelidBehavior = (DAZMeshEyelidControl) containingAtom.GetStorableByID("EyelidControl");
			jawControl = (AdjustJoints)containingAtom.GetStorableByID("JawControl");
			jawControl.SetBoolParamValue("driveXRotationFromAudioSource", true);
			// autoJawMouthMorphs = containingAtom.GetStorableByID("AutoJawMouthMorph");
			DAZCharacterSelector characterSelector = SlapMe.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			morphControl = characterSelector.morphsControlUI;
			string joyMorphPath = SlapMe.packageUid + "Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Expressions/Joy/";
			string painMorphPath = SlapMe.packageUid + "Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Expressions/Displease";
			foreach (var path in FileManagerSecure.GetFiles(joyMorphPath + "Ascorad"))
			{
				if(path.EndsWith(".vmb")) continue;
				var pathNormalized = FileManagerSecure.NormalizePath(path);
				joyMorphs.Add(GetMorph(pathNormalized));
			}
			foreach (var path in FileManagerSecure.GetFiles(joyMorphPath + "AshAuryn"))
			{
				if(path.EndsWith(".vmb")) continue;
				var pathNormalized = FileManagerSecure.NormalizePath(path);
				joyMorphs.Add(GetMorph(pathNormalized));
			}
			foreach (var path in FileManagerSecure.GetFiles(painMorphPath))
			{
				if(path.EndsWith(".vmb")) continue;
				var pathNormalized = FileManagerSecure.NormalizePath(path);
				painMorphs.Add(GetMorph(pathNormalized));
			}
			joyMorphs.Add(GetMorph("Desire"));
			joyMorphs.Add(GetMorph("Excitement"));
			joyMorphs.Add(GetMorph("Flirting"));
			joyMorphs.Add(GetMorph("Flirting Feminine Left"));
			joyMorphs.Add(GetMorph("Flirting Feminine Right"));
			joyMorphs.Add(GetMorph("Flirting Masculine Left"));
			joyMorphs.Add(GetMorph("Flirting Masculine Right"));
			joyMorphs.Add(GetMorph("Frown"));
			joyMorphs.Add(GetMorph("Sad"));
			joyMorphs.Add(GetMorph("Scream"));
			joyMorphs.Add(GetMorph("Shock"));
			joyMorphs.Add(GetMorph("Smile Full Face"));
			joyMorphs.Add(GetMorph("Snarl Left"));
			joyMorphs.Add(GetMorph("Snarl Right"));
			joyMorphs.Add(GetMorph("Surprise"));
			
			// joyMorphpsBrows.Add(GetMorph("Brow Down"));
			joyMorphs.Add(GetMorph("Brow Down Left"));
			joyMorphs.Add(GetMorph("Brow Down Right"));
			// joyMorphps.Add(GetMorph("Brow Inner Down"));
			joyMorphs.Add(GetMorph("Brow Inner Down Left"));
			joyMorphs.Add(GetMorph("Brow Inner Down Right"));
			joyMorphs.Add(GetMorph("Brow Inner Up Left"));
			joyMorphs.Add(GetMorph("Brow Inner Up Right"));
			// joyMorphps.Add(GetMorph("Brow Outer Down Left"));
			joyMorphs.Add(GetMorph("Brow Outer Down Left"));
			joyMorphs.Add(GetMorph("Brow Outer Down Right"));
			// joyMorphps.Add(GetMorph("Brow Outer Up"));
			joyMorphs.Add(GetMorph("Brow Outer Up Left"));
			joyMorphs.Add(GetMorph("Brow Outer Up Right"));
			// joyMorphps.Add(GetMorph("Brow Up"));
			joyMorphs.Add(GetMorph("Brow Up Left"));
			joyMorphs.Add(GetMorph("Brow Up Right"));
			joyMorphs.Add(GetMorph("Brow Squeeze"));
			
			joyMorphs.Add(GetMorph("Eyes Closed"));
			joyMorphs.Add(GetMorph("Eyes Squint"));
			joyMorphs.Add(GetMorph("Eyes Squint Left"));
			joyMorphs.Add(GetMorph("Eyes Squint Right"));
			
			// joyMorphs.Add(GetMorph("Mouth Open"));
			// joyMorphs.Add(GetMorph("Mouth Open Wide"));
			// joyMorphs.Add(GetMorph("Mouth Narrow"));
			// joyMorphs.Add(GetMorph("Mouth Narrow Left"));
			// joyMorphs.Add(GetMorph("Mouth Narrow Right"));
			joyMorphs.Add(GetMorph("Mouth Side-Side Left"));
			joyMorphs.Add(GetMorph("Mouth Side-Side Right"));
			joyMorphs.Add(GetMorph("Mouth Smile"));
			joyMorphs.Add(GetMorph("Mouth Smile Open"));
			// joyMorphs.Add(GetMorph("Mouth Smile Simple"));
			joyMorphs.Add(GetMorph("Mouth Smile Simple Left"));
			joyMorphs.Add(GetMorph("Mouth Smile Simple Right"));
			
			joyMorphs.Add(GetMorph("Lip Bottom Down"));
			joyMorphs.Add(GetMorph("Lip Bottom Out"));
			// joyMorphps.Add(GetMorph("Lip Bottom In"));
			joyMorphs.Add(GetMorph("Lip Bottom In Left"));
			joyMorphs.Add(GetMorph("Lip Bottom Out Right"));
			joyMorphs.Add(GetMorph("Lip Bottom Up"));
			joyMorphs.Add(GetMorph("Lip Bottom Up Left"));
			joyMorphs.Add(GetMorph("Lip Bottom Up Right"));
			// joyMorphs.Add(GetMorph("Lip Top Up"));
			joyMorphs.Add(GetMorph("Lip Top Up Left"));
			joyMorphs.Add(GetMorph("Lip Top Up Right"));
			joyMorphs.Add(GetMorph("Lips Close"));
			joyMorphs.Add(GetMorph("Lips Part"));
			// joyMorphs.Add(GetMorph("Lips Pucker"));
			joyMorphs.Add(GetMorph("Lips Pucker Wide"));
			enabledJSON.setCallbackFunction += val => Reset();
			
			headAudioSource = containingAtom.GetStorableByID("HeadAudioSource").GetComponent<AudioSource>();
			moanLibrary = new List<ClipLibrary>
			{
				new ClipLibrary("moans0"),
				new ClipLibrary("moans1"),
				new ClipLibrary("moans2"),
				new ClipLibrary("moans3"),
				new ClipLibrary("moans4"),
				new ClipLibrary("moans5"),
			};
			var moansettings = new MoanSettings();
			
			var vammoan = this.FindPluginPeer("VAMMoan");
			if (vammoan)
			{
				vamMoanVoice = vammoan.GetStringChooserJSONParam("voice");
				voice.val = vamMoanVoice.val;
				vamMoanVoice.setCallbackFunction += val => voice.val = val;
			}
			else RetrySyncWithVamMoan().Start();
			voice.setCallbackFunction += val =>
			{
				AudioImporter.ReadBundle("VAMMoan", moanLibrary);
				if (vamMoanVoice != null) vamMoanVoice.val = val;
			};
			
			string vamMoanPackageUid = CheesyUtils.GetLatestPackageUid("hazmhox.vammoan");
			if (vamMoanPackageUid != null)
			{
				vammoanPackageInstalled = true;
				string moanPath = vamMoanPackageUid + ":/Custom/Scripts/VAMMoan/audio/voices.voicebundle";
				AudioImporter.GetClipsFromAssetBundle(moanLibrary, moanPath);
				var squishPath = vamMoanPackageUid + ":/Custom/Scripts/VAMMoan/audio/voices-shared.voicebundle";
				AudioImporter.GetClipsFromAssetBundle(new List<ClipLibrary>{FillMeUp.squishLibrary, FillMeUp.bjLibrary},
					squishPath);
			}
			else
			{
				vammoanPackageInstalled = false;
				slapMoanChance.val = 0f;
				sexSlapMoanChance.val = 0f;
			}
			slapMoanChance.setCallbackFunction += val =>
			{
				if (!vammoanPackageInstalled)
				{
					SuperController.LogError("SlapMe: Download VAMMoan to enable moan reactions.");
					slapMoanChance.valNoCallback = 0f;
				}
			};
			sexSlapMoanChance.setCallbackFunction += val =>
			{
				if (!vammoanPackageInstalled)
				{
					SuperController.LogError("SlapMe: Download VAMMoan to enable moan reactions.");
					sexSlapMoanChance.valNoCallback = 0f;
				}
			};
			randomBurstChanceJ.AddCallback(val => randomBurstChance = .01f * val);
			// idleBurstChanceJ.AddCallback(val => idleBurstChance = );
			sexMoanChanceJ.AddCallback(val => sexMoanChance = .1f * val);
			stimulationRegressionJ.AddCallback(val => stimulationRegression = val);
			painThresholdJ.AddCallback(val => painThreshold = val);
			orgasmRecoverTime.AddCallback(val => orgRecoverTimer = val);
			jawLimit.AddCallback((val => jawControl.SetFloatParamValue("driveXRotationFromAudioSourceMaxAngle", val)));
			headAudioVolume.AddCallback(val => headAudioControl.SetFloatParamValue("volume", val));
			headAudioPitch.AddCallback(val => headAudioControl.SetFloatParamValue("pitch", val));
			
			SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
			
			lastMorphs.Add(joyMorphs[0]);

			onOrgasmStartTrigger = new EventTrigger(this, "On Orgasm Start");
			onOrgasmEndTrigger = new EventTrigger(this, "On Orgasm End");
			onOrgasmRecoverTrigger = new EventTrigger(this, "On Orgasm Recover");
			AddTrigger();
			
			var labiaListener = BodyRegionMapping.touchZones["Labia"].touchCollisionListener;
			labiaListener.onEnterEvent.AddListener(SetIdleMode);
			labiaListener.onExitEvent.AddListener(SetIdleMode);
			
			RegisterFloat(randomBurstChanceJ);
			RegisterFloat(randomBurstStrenght);
			RegisterFloat(joyExpressionScale);
			RegisterFloat(painThresholdJ);
			RegisterFloat(painExpressionScale);
			RegisterFloat(jawLimit);
			RegisterFloat(headAudioVolume);
			RegisterFloat(headAudioPitch);
			// RegisterFloat(maxMorphVal);
			RegisterFloat(expressionsChangeChance);
			RegisterFloat(stimulationGain);
			RegisterFloat(stimulationRegressionJ);
			RegisterFloat(orgasmThreshold);
			RegisterFloat(orgasmRecoverTime);
			RegisterFloat(sexMoanChanceJ);
			RegisterFloat(slapMoanChance);
			RegisterFloat(sexSlapMoanChance);
			RegisterFloat(burstMoanChance);
			foreach (var setting in MoanSettings.thresholds)
			{
				RegisterFloat(setting);
			}
			
			
			UIManager.SetScript(this, CreateUIElement, leftUIElements, rightUIElements);
			Utils.OnInitUI(CreateUIElement);
			CreateUI();
			Reset();
			// PrintMorphFile();
			LoadExpressionSets();
			foreach (var morph in joyMorphs)
			{
				morph.isSmile = expressionSets["general"][morph.uid].AsObject["isSmile"].AsBool;
			}
		}

		public override void InitUI()
		{
			base.InitUI();
			if(UITransform == null || uiListener != null) return;
			uiListener = UITransform.gameObject.AddComponent<UnityEventsListener>();
			uiListener.onEnabled.AddListener(() => UIManager.SetScript(this, CreateUIElement, leftUIElements, rightUIElements));
		}

		private void OnDestroy()
		{
			Reset();
			onOrgasmStartTrigger.Remove();
			onOrgasmEndTrigger.Remove();
			onOrgasmRecoverTrigger.Remove();
		}
		
		public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
		{
			JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
			if (includePhysical || forceStore)
			{
				needsStore = true;
				jc[onOrgasmStartTrigger.Name] = onOrgasmStartTrigger.GetJSON(base.subScenePrefix);
				jc[onOrgasmEndTrigger.Name] = onOrgasmEndTrigger.GetJSON(base.subScenePrefix);
				jc[onOrgasmRecoverTrigger.Name] = onOrgasmRecoverTrigger.GetJSON(base.subScenePrefix);
				for (int i = 0; i < stimTriggers.Count; i++)
				{
					jc[stimTriggers[i].name] = stimTriggers[i].Store(subScenePrefix);
				}
			}
			return jc;
		}

		public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
		{
			base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);

			if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
			{
				needsStore = true;
				onOrgasmStartTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
				onOrgasmEndTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
				onOrgasmRecoverTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
				for (int i = 0; i < stimTriggers.Count; i++)
				{
					stimTriggers[i].Load(jc, subScenePrefix);
				}
				foreach (var setting in MoanSettings.thresholds)
				{
					setting.RestoreFromJSON(jc);
				}
			}
		}

		public void OnAtomRename(string oldUid, string newUid)
		{
			stimTriggers.ForEach(x => x.OnAtomRename());
			orgasmTriggers.ForEach(x => x.OnAtomRename());
			onOrgasmStartTrigger.SyncAtomNames();
			onOrgasmEndTrigger.SyncAtomNames();
			onOrgasmRecoverTrigger.SyncAtomNames();
		}
		
		private void CreateUI()
		{
			// UIManager.SetScript(this, CreateUIElement, leftUIElements, rightUIElements);
			RemoveUIElements(UIElements);
			stimulation.CreateUI(this);
			orgasmCount.CreateUI(this, true);
			tabbar = UIManager.CreateTabBar(new [] {"Stimulation", "Expressions", "Voice"}, SelectTab, script:this);
			tabbar.SelectTab(lastTabId);
		}

		private int lastTabId;
		public void ClearUI()
		{
			RemoveUIElements(leftUIElements.Select(x => (object) x.GetComponent<UIDynamic>()).ToList());
			RemoveUIElements(rightUIElements.Select(x => (object) x.GetComponent<UIDynamic>()).ToList());
		}

		private void SelectTab(int id)
		{
			lastTabId = id;
			RemoveUIElements(UIElements);
			if(id == 0) CreateStimUI();
			else if (id == 1) CreateExpressionsUI();
			else CreateVoiceUI();
		}

		private void CreateStimUI()
		{
			stimulationGain.CreateUI(script: this, rightSide:true, UIElements:UIElements);
			stimulationRegressionJ.CreateUI(script: this, rightSide:true, UIElements:UIElements);
			orgasmThreshold.CreateUI(UIElements: UIElements);
			painThresholdJ.CreateUI(UIElements: UIElements, rightSide:true);
			orgasmRecoverTime.CreateUI(UIElements: UIElements);
			var button = CreateButton("Stimulation Triggers");
			button.buttonColor = new Color(0.45f, 1f, 0.45f);
			button.button.onClick.AddListener(() =>
			{
				{
					ClearUI();
					stimTriggers[0].OpenPanel(this, CreateUI);
				}
			});
			UIElements.Add(button);
			button = CreateButton("Orgasm Value Triggers");
			button.buttonColor = new Color(0.45f, 1f, 0.45f);
			button.button.onClick.AddListener(() =>
			{
				{
					ClearUI();
					orgasmTriggers[0].OpenPanel(this, CreateUI);
				}
			});
			UIElements.Add(button);
			button = CreateButton("On Orgasm Start");
			button.buttonColor = new Color(0.45f, 1f, 0.45f);
			button.button.onClick.AddListener(onOrgasmStartTrigger.OpenPanel);
			UIElements.Add(button);
			button = CreateButton("On Orgasm End");
			button.buttonColor = new Color(0.45f, 1f, 0.45f);
			button.button.onClick.AddListener(onOrgasmEndTrigger.OpenPanel);
			UIElements.Add(button);
			button = CreateButton("On Orgasm Recover");
			button.buttonColor = new Color(0.45f, 1f, 0.45f);
			button.button.onClick.AddListener(onOrgasmRecoverTrigger.OpenPanel);
			UIElements.Add(button);
		}

		private void CreateExpressionsUI()
		{
			joyExpressionScale.CreateUI(this, UIElements:UIElements);
			painExpressionScale.CreateUI(this, UIElements:UIElements, rightSide:true);
			// maxMorphVal.CreateUI(this, UIElements:UIElements);
			expressionsChangeChance.CreateUI(this, UIElements:UIElements, rightSide:true);
			randomBurstChanceJ.CreateUI(this, UIElements:UIElements);
			randomBurstStrenght.CreateUI(this, UIElements:UIElements);
			jawLimit.CreateUI(this, UIElements:UIElements, rightSide:true);
		}
		
		private void CreateVoiceUI()
		{
			voice.CreateUI(script: this, rightSide:true, chooserType:1, UIElements:UIElements);
			sexMoanChanceJ.CreateUI(script: this, UIElements:UIElements, rightSide:true);
			burstMoanChance.CreateUI(script: this, UIElements:UIElements, rightSide:true);
			slapMoanChance.CreateUI(script: this, UIElements:UIElements, rightSide:true);
			sexSlapMoanChance.CreateUI(script: this, rightSide:true, UIElements:UIElements);
			
			foreach (var setting in MoanSettings.thresholds)
			{
				setting.CreateUI(script: this, UIElements: UIElements);
			}
			orgasmThreshold.CreateUI(script: this, UIElements: UIElements);
			headAudioVolume.CreateUI(script: this, UIElements:UIElements, rightSide:true);
			headAudioPitch.CreateUI(script: this, UIElements:UIElements, rightSide:true);
		}

		public static void Stimulate(float stimulus, bool doChange = false, bool doStim = false)
		{
			float stim = stimulus * .01f;
			stimBurstTimer = .2f;
			if (doChange)
			{
				if (stimulation.val <= .01f)
				{
					resetTargetsTimer = stimBurstTimer = Random.Range(.5f, 4f);
				}
				resetTargetsTimer = 1f;
			}
			DistributeStimulus(stim*(1f+2f*stimulation.val*stimulation.val), doChange);
			if(!isIdling || doStim)
			{
				stimulation.val += stim * stimulationGain.val;
				if (!isOrgasming && stimulation.val >= orgasmThreshold.val)
				{
					isOrgasming = true;
					isOrgasmEnd = true;
					orgasmCount.val += 1f;
					Stimulate(3f, true);
					onOrgasmStartTrigger.Trigger();
				}
			}
		}

		private static float smileSum;
		private static float totalSum;
		private const float maxSmile = .05f;
		private const float minIncrement = .05f;
		
		public static void DistributeStimulus(float stim, bool doChange){
			float available = stim;
			List<ExpressionMorph> morphs;
			float factor;
			if(stimulation.val >= painThreshold){
				morphs = new List<ExpressionMorph>(painMorphs);
				factor = painExpressionScale.val;
				// factor = Mathf.Lerp(painExpressionScale.val, painExpressionScale.val * .25f,
				// 	(stimulation.val - painTreshold.val)/(1f - painTreshold.val));
			}
			else{
				morphs = new List<ExpressionMorph>(joyMorphs);
				factor = Mathf.Lerp(joyExpressionScale.val*1.5f, joyExpressionScale.val * .25f, stimulation.val);
			}

			
			available *= factor;
			List<ExpressionMorph> rndMorphs;
			if (!doChange && Random.Range(0f, 1f) > expressionsChangeChance.val)
			{
				foreach(var morph in lastMorphs)
				{
					if (available <= minIncrement) break;
					float maxIncrement = Math.Min(available, maxMorphVal.val - morph.target);
					if (morph.isSmile) maxIncrement = Mathf.Min(maxIncrement, maxSmile-smileSum);
					if(maxIncrement < minIncrement) continue;
					float increment = Random.Range(minIncrement, maxIncrement);
					morph.target += increment;
					available -= increment;
					if (morph.isSmile) smileSum += morph.target;
				}
			}
			else
			{
				lastMorphs.Clear();
				for (var i = 0; i < morphs.Count; i++)
				{
					if (available <= minIncrement) break;
					var morph = morphs[rng.Next(morphs.Count)];
					float maxIncrement = Math.Min(available, maxMorphVal.val - morph.target);
					if (morph.isSmile) maxIncrement = Mathf.Min(maxIncrement, maxSmile-smileSum);
					if(maxIncrement < minIncrement) continue;
					float increment = Random.Range(minIncrement, maxIncrement);
					morph.target += increment;
					available -= increment;
					lastMorphs.Add(morph);
					if (morph.isSmile) smileSum += morph.target;
				}
				// lastMorphs.Count.Print();
			}
			// foreach(var morph in rndMorphs)
			// {
			// 	float increment = Random.Range(0f, Math.Min(available, Mathf.Abs(maxMorphVal.val - morph.target)));
			// 	morph.target += increment;
			// 	available -= increment;
			// 	lastMorphs.Add(morph);
			// 	if (available <= .01f) break;
			// }
			if(targetsReset) targetsReset = false;
			
			smileSum = 0f;
		}

		private static bool targetsReset;
		private float burstTimer;
		public void Update()
		{
			onOrgasmStartTrigger.Update();
			onOrgasmEndTrigger.Update();
			onOrgasmRecoverTrigger.Update();
			
			if(isIdling)
			{
				burstTimer -= Time.deltaTime;
				if (burstTimer < 0f)
				{
					burstTimer = .2f;

					if (randomBurstChanceJ.val >= .999f || (randomBurstChance > 0f && randomBurstStrenght.val > 0f &&
					    Random.Range(0f, 1f) <= randomBurstChanceJ.val))
					{
						Stimulate(randomBurstStrenght.val, true);
						PlayBurstMoan();
					}
				}
			}
			
			orgRecoverTimer -= Time.deltaTime;
			if (orgRecoverTimer < 0f)
			{
				onOrgasmRecoverTrigger.Trigger();
				if (orgasmCount.val > 0)
				{
					orgasmCount.val -= 1;
					stimulationRegression = stimulationRegressionJ.val * Mathf.Log(2f*orgasmCount.val + 1f);
				}
				orgRecoverTimer = orgasmRecoverTime.val;
			}
			if (isOrgasming || isOrgasmEnd)
			{
				
				orgasmTimer -= Time.deltaTime;
				if (orgasmTimer < 20f)
				{
					painThreshold = stimulation.val - .05f;
					if(isOrgasming)
					{
						isOrgasming = false;
						stimulationRegression = stimulationRegressionJ.val * 5f * orgasmCount.val;
					}
					if (orgasmTimer < 0f)
					{
						onOrgasmEndTrigger.Trigger();
						orgasmTimer = 30f;
						stimulationRegression = stimulationRegressionJ.val * Mathf.Log(2f*orgasmCount.val + 1f);
						painThreshold = painThresholdJ.val;
						isOrgasmEnd = false;
					}
				}
			}
			
			if(blinkTimeout > 0f) blinkTimeout -= Time.deltaTime;
			if(stimulation.val > .01f){
				stimulation.val = Mathf.Lerp(stimulation.val, 0f, stimulationRegression*Time.deltaTime);
			}
			
			// if(lastMorphs[0].target >0f) lastMorphs[0].target.Print();
			// else if(!isReset) ResetTargets();
			if(resetTargetsTimer > 0f) resetTargetsTimer -= Time.deltaTime;
			if(stimBurstTimer > 0f) stimBurstTimer -= Time.deltaTime;
			// if(lastMorphs[0].target >0f) lastMorphs[0].target.Print();
			foreach(var morph in painMorphs)
			{
				morph.LerpToTarget();
			}
			foreach(var morph in joyMorphs){
				// if(morph.target > 0f) $"{morph.name} {morph.target} {morph.val}".Print();
				morph.LerpToTarget();
				
			}
			if(!targetsReset && (resetTargetsTimer <= 0f || stimBurstTimer <= 0f))
			{
				foreach(var morph in painMorphs){
					if(morph.target > 0f) morph.target = 0f;
				}
				foreach(var morph in joyMorphs){
					if(morph.target > 0f) morph.target = 0f;
				}
				targetsReset = true;
				resetTargetsTimer = 1f;
			}
		}

		// void AdjustNipples(float erection){
		// 	nippleSpring.val = Mathf.Lerp(nippleSpring.defaultVal, 15f, erection);
		// 	nippleDamper.val = Mathf.Lerp(nippleDamper.defaultVal, 3f, erection);
		// 	nippleMorph.jsonFloat.val = erection;
		// }

		private void ResetTargets()
		{
			foreach(var morph in painMorphs)
			{
				morph.target = 0f;
			}
			
			foreach (var morph in joyMorphs)
			{
				morph.target = 0f;
			}
		}

		public static void Reset(){
			foreach(var morph in painMorphs)
			{
				morph.val = 0f;
				morph.target = 0f;
			}
			
			foreach (var morph in joyMorphs)
			{
				morph.val = 0f;
				morph.target = 0f;
			}
			stimulation.val = 0f;
		}

		private ExpressionMorph GetMorph(string uid)
		{
			DAZMorph morph = morphControl.GetMorphByUid(uid);
			if (morph == null) uid.Print();
			// morph.displayName.Print();
			// morph.morphValue.Print();
			return new ExpressionMorph(morph);
		}

		public static void PlaySlapMoan(bool isSexSlap = false)
		{
			if(FillMeUp.throat.depth.val > .02f || headAudioSource.isPlaying) return;
			bool doMoan;
			if (isSexSlap) doMoan = sexSlapMoanChance.val > 0f && Random.Range(0f, 1f) < sexSlapMoanChance.val;
			else doMoan = slapMoanChance.val > 0f && Random.Range(0f, 1f) <= slapMoanChance.val;
			if (doMoan)
			{
				int lvl = GetMoanLevel();
				lvl = rng.Next(lvl, 5);
				moanLibrary[lvl].Play(headAudioSource);
			}
		}
		
		public static void PlayBurstMoan()
		{
			if(FillMeUp.throat.depth.val > .02f || headAudioSource.isPlaying || burstMoanChance.val == 0f) return;
			if (Random.Range(0f, 1f) <= burstMoanChance.val)
			{
				moanLibrary[GetMoanLevel()].Play(headAudioSource);
			}
		}
		
		public static bool PlayMoan()
		{
			if(FillMeUp.throat.depth.val > .02f || headAudioSource.isPlaying || sexMoanChance == 0f || stimulation.val == 0f) return false;
			if (Random.Range(0f, 1f) <= sexMoanChance * stimulation.val)
			{
				moanLibrary[GetMoanLevel()].Play(headAudioSource);
				return true;
			}
			return false;
		}

		private static int GetMoanLevel()
		{
			if (isOrgasming) return 5;
			if(stimulation.val < MoanSettings.thresholds[0].val) return 0;
			for (var i = MoanSettings.thresholds.Count - 1; i > 0; i--)
			{
				var threshold = MoanSettings.thresholds[i];
				if (stimulation.val <= threshold.val) continue;
				return i+1;
			}
			return 1;
		}
		
		private IEnumerator RetrySyncWithVamMoan()
		{
			yield return new WaitForEndOfFrame();
			for (int i = 0; i < 5; i++)
			{
				yield return new WaitForSeconds(2f);
				var vammoan = this.FindPluginPeer("VAMMoan");
				if (vammoan)
				{
					vamMoanVoice = vammoan.GetStringChooserJSONParam("voice");
					voice.val = vamMoanVoice.val;
					vamMoanVoice.setCallbackFunction += val => voice.val = val;
					yield break;
				}
			}
		}

		public void AddTrigger()
		{
			var trigger = gameObject.AddComponent<CustomFloatTrigger>();
			trigger.Init(this, stimulation, $"{stimulation.name}_{stimTriggers.Count}");
			stimTriggers.Add(trigger);
			trigger = gameObject.AddComponent<CustomFloatTrigger>();
			trigger.Init(this, orgasmCount, $"{orgasmCount.name}_{orgasmTriggers.Count}", false, 1f);
			orgasmTriggers.Add(trigger);
		}
		
		public void RemoveUIElements(List<object> UIElements)
		{
			for (int i=0; i<UIElements.Count; ++i)
			{
				if(UIElements[i] == null) continue;
				if (UIElements[i] is JSONStorableParam)
				{
					JSONStorableParam jsp = UIElements[i] as JSONStorableParam;
					if (jsp is JSONStorableFloat)
						RemoveSlider(jsp as JSONStorableFloat);
					else if (jsp is JSONStorableBool)
						RemoveToggle(jsp as JSONStorableBool);
					else if (jsp is JSONStorableColor)
						RemoveColorPicker(jsp as JSONStorableColor);
					else if (jsp is JSONStorableString)
						RemoveTextField(jsp as JSONStorableString);
					else if (jsp is JSONStorableStringChooser)
					{
						// Workaround for VaM not cleaning its panels properly.
						JSONStorableStringChooser jssc = jsp as JSONStorableStringChooser;
						RectTransform popupPanel = jssc.popup?.popupPanel;
						RemovePopup(jssc);
						if (popupPanel != null)
							UnityEngine.Object.Destroy(popupPanel.gameObject);
					}
				}
				else if (UIElements[i] is UIDynamic)
				{
					UIDynamic uid = UIElements[i] as UIDynamic;
					if (uid is UIDynamicButton)
						RemoveButton(uid as UIDynamicButton);
                    else if (uid is UIDynamicSlider)
						RemoveSlider(uid as UIDynamicSlider);
					else if (uid is UIDynamicToggle)
						RemoveToggle(uid as UIDynamicToggle);
					else if (uid is UIDynamicColorPicker)
						RemoveColorPicker(uid as UIDynamicColorPicker);
					else if (uid is UIDynamicTextField)
						RemoveTextField(uid as UIDynamicTextField);
					else if (uid is UIDynamicPopup)
					{
						// Workaround for VaM not cleaning its panels properly.
						UIDynamicPopup uidp = uid as UIDynamicPopup;
						RectTransform popupPanel = uidp.popup?.popupPanel;
						RemovePopup(uidp);
						if (popupPanel != null)
							UnityEngine.Object.Destroy(popupPanel.gameObject);
					}
                    else if (uid is UIDynamicV3Slider)
                    {
                        var v3Slider = uid as UIDynamicV3Slider;
                        leftUIElements.Remove(v3Slider.transform);
                        rightUIElements.Remove(v3Slider.spacer.transform);
                        Destroy(v3Slider.spacer.gameObject);
                        Destroy(v3Slider.gameObject);
                    }
                    else if (uid is UIDynamicTabBar)
                    {
                        var tabbar = uid as UIDynamicTabBar;
                        leftUIElements.Remove(tabbar.transform);
                        rightUIElements.Remove(tabbar.spacer.transform);
                        Destroy(tabbar.spacer.gameObject);
                        Destroy(tabbar.gameObject);
                    }
                    else
						RemoveSpacer(uid);
				}
			}

			UIElements.Clear();
		}

		private void PrintMorphFile()
		{
			JSONClass existing = null;
			JSONClass joy = new JSONClass();
			// if(FileManagerSecure.FileExists("Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/joy/general.json"))
			// {
			// 	existing = LoadJSON("Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/joy/general.json").AsObject;
			// 	FileManagerSecure.DeleteFile("Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/joy/general.json");
			// }
			foreach (var morph in joyMorphs)
			{
				morph.uid.Print();
				joy["set"] = "general";
				joy[morph.uid]["isSmile"].AsBool = morph.name.ToLower().Contains("smile") || (existing != null && existing[morph.uid].AsObject["isSmile"].AsBool);
				joy[morph.uid]["weight"].AsFloat = 1f;
				joy[morph.uid]["max"].AsFloat = 0.1f;
				joy[morph.uid]["exclude"] = new JSONArray();
			}
			
			if(FileManagerSecure.FileExists("Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/pain/general.json"))
			{
				existing = LoadJSON("Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/pain/general.json").AsObject;
				FileManagerSecure.DeleteFile("Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/pain/general.json");
			}
			JSONClass pain = new JSONClass();
			foreach (var morph in painMorphs)
			{
				pain["set"] = "general";
				pain[morph.uid]["isSmile"].AsBool = morph.name.ToLower().Contains("smile") || (existing != null && existing[morph.uid].AsObject["isSmile"].AsBool);
				pain[morph.uid]["weight"].AsFloat = 1f;
				pain[morph.uid]["max"].AsFloat = 0.1f;
				pain[morph.uid]["exclude"] = new JSONArray();
			}

			SaveSets(joy, pain);
		}

		private void SaveSets(JSONClass joy, JSONClass pain)
		{
			SaveJSON(joy, "Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/joy/general.json");
			SaveJSON(pain, "Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/pain/general.json");
		}

		private Dictionary<string, JSONClass> expressionSets = new Dictionary<string, JSONClass>();
		private void LoadExpressionSets()
		{
			string packageUid = Utils.GetPackagePath(this);
			var joySets = packageUid + "Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/joy";
			var painSets = packageUid + "Custom/Scripts/CheesyFX/BodyLanguage/ExpressionSets/pain";
			foreach (var path in FileManagerSecure.GetFiles(joySets))
			{
				var normalizedPath = FileManagerSecure.NormalizePath(path);
				var jc = LoadJSON(normalizedPath).AsObject;
				// jc.Keys.ToList().ForEach(x => x.Print());
				expressionSets[jc["set"]] = jc;
			}
		}
		
		public static void SetIdleMode()
		{
			var idling = !(FillMeUp.orifices.Any(x => x.isPenetrated) || BodyRegionMapping.touchZones["Labia"].touchCollisionListener.isOnStay);
			if (isIdling == idling) return;
			isIdling = idling;
			if (idling)
			{
				ExpressionMorph.quicknessIn = 2f;
				ExpressionMorph.quicknessOut = .5f;
			}
			else
			{
				ExpressionMorph.quicknessIn = 4f;
				ExpressionMorph.quicknessOut = 2f;
			}
		}
	}
	
	public class ExpressionMorph
	{
		private DAZMorph dazMorph;
		public bool isSmile;
		public float weight;
		private bool isAtTarget;
		public static float quicknessIn = 2f;
		public static float quicknessOut = .5f;
		public string name => dazMorph.displayName;
		public string uid => dazMorph.uid;
		private float _target;
		public float target
		{
			get { return _target; }
			set
			{
				if (_target == value) return;
				_target = value;
				isAtTarget = false;
			}
		}

		public float val
		{
			get { return dazMorph.morphValue; }
			set { dazMorph.morphValue = value; }
		}

		public ExpressionMorph(DAZMorph dazMorph)
		{
			this.dazMorph = dazMorph;
		}

		public void LerpToTarget()
		{
			if (!isAtTarget && Mathf.Abs(val - _target) < .001f)
			{
				val = _target;
				isAtTarget = true;
				return;
			}
			if(_target > 0) val = Mathf.Lerp(val, _target, quicknessIn*Time.deltaTime);
			else val = Mathf.Lerp(val, _target, quicknessOut*Time.deltaTime);
		}
	}

	public class MoanSettings
	{
		public static List<JSONStorableFloat> thresholds = new List<JSONStorableFloat>();

		public MoanSettings()
		{
			for (int i = 0; i < 4; i++)
			{
				var setting = new JSONStorableFloat($"Level {i+1} Threshold", .1f + .2f * i, 0f, 1f);
				thresholds.Add(setting);
				// setting.setCallbackFunction += val => SyncRanges();
			}
		}

		// private void SyncRanges()
		// {
		// 	for (var i = 0; i < thresholds.Count-1; i++)
		// 	{
		// 		thresholds[i + 1].min = thresholds[i].val;
		// 		thresholds[i].max = thresholds[i+1].val;
		// 	}
		// }
	}
}