using System.Collections.Generic;
using Leap.Unity;
using UnityEngine;

namespace CheesyFX
{
    public class ClipLibrary
    {
        public string name;
        public float baseVolume = 1f;
        public float basePitch = 1f;
        public List<AudioClip> clips = new List<AudioClip>();
        private List<AudioClip> remainingClips = new List<AudioClip>();
        private System.Random rnd = new System.Random();
        

        public ClipLibrary(string name)
        {
            this.name = name;
        }

        public void AddClip(AudioClip clip)
        {
            clips.Add(clip);
            remainingClips.Add(clip);
        }

        public void Clear()
        {
            clips.Clear();
            remainingClips.Clear();
        }

        public void Play(AudioSource audioSource)
        {
            audioSource.clip = GetRandomClip();
            audioSource.Play();
        }
        
        public AudioClip GetRandomClip()
        {
            if (clips.Count == 0) return null;
            AudioClip clip;
            if(clips.Count == 1) clip = clips[0];
            else{
                int id = rnd.Next(0, remainingClips.Count);
                clip = remainingClips[id];
                remainingClips.Remove(clip);
                if(remainingClips.Count == 0) remainingClips = new List<AudioClip>(clips);
            }
            return clip;
        }
    }
}